#!/usr/bin/ruby

require 'trollop'

opts = Trollop::options do
  opt :_version, "print out version", # The _ is because Trollop is stupid
    long: 'version', short: 'v'

  opt :album, "album name",
    long: 'album', short: 'A', type: :string

  opt :song, "song name",
    long: 'song', short: 's', type: :string

  opt :artist, "artist name",
    long: "artist", short: "a", type: :string

  opt :playlist, "playlist name",
    long: "playlist", short: "p", type: :string

  opt :username, "spotify username",
    long: "user", short: "u", type: :string

  opt :post_processors, "post processors",
    long: "post-processors", short: "P", type: :string

  opt :resume, "resume a download that failed was cancelled",
    long: "resume", short: "r"
  
  opt :quick, "make it go QUICK.",
    long: "quick", short: "q"
end


album = opts[:album]
song = opts[:song]
artist = opts[:artist]
playlist = opts[:playlist]
username = opts[:username]
post_processors = ({post_processors: opts[:post_processors].to_s.split(" ")})
compilation = {compilation: opts[:compilation]}

args = {
  album: album,
  song: song,
  artist: artist,
  playlist: playlist,
  username: username,
}.merge(compilation).merge(post_processors)

require 'irs'
ripper = IRS::Ripper.new(args)

if opts[:quick]
  def sleep(x=[]); end
end

if opts[:_version]
  IRS::Utils.banner
  exit
end

if opts[:resume]
  ripper.resume
elsif album
  ripper.spotify_list("album", album)
elsif playlist && username
  ripper.spotify_list("playlist", playlist, username)
elsif song && artist
  ripper.song(song, artist)
else
  IRS::Utils.console
end
