require 'rspotify'

module IRS

  class Metadata

    class << self

      def parse_genre(genres)
        if genres != []
          genres.reverse!
          genres.map!{|g| g.tr(" - ", " ").tr("-", " ")}


          single = genres.sort_by{|g| g.split.size}[0]

          return IRS::Utils.capitalize_all(single) if !(single.split.size > 1)

          genres.map!{|g| g if g.split("-").size <= 1}.compact

          return IRS::Utils.capitalize_all(genres[0])
        end
      end

      def find_album(song, artist)
        tracks = RSpotify::Track.search(song + " " + artist)
        tracks.each do |track|
          if track.name.include?(song)
            if track.artists[0].name.include?(artist)
              return track.album
            end
          end
        end
        return
      end

    end
  end
end
